<?php
/**
 * The default template for displaying content
 *
 */
?>

<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
	<header class="entry-header">

		<?php if ( is_single() ) : ?>
		<h2 class="entry-title"><?php the_title(); ?></h2>
		<?php else : ?>
		<h2 class="entry-title">
			<a href="<?php the_permalink(); ?>" rel="bookmark"><?php the_title(); ?></a>
		</h2>
		<?php endif; // is_single() ?>

		<?php entry_date() ?>
		<?php if ( has_post_thumbnail() && ! post_password_required() && ! is_attachment() ) : ?>
		<div class="entry-thumbnail">
			<?php the_post_thumbnail(); ?>
		</div>
		<?php endif; ?>
	</header><!-- .entry-header -->

	<div class="entry-content">
		<?php the_content( __( '全文阅读 <span class="meta-nav">&rarr;</span>', 'twentythirteen' ) ); ?>
		<?php if ( is_single( )) : ?>
		<?php wp_link_pages( array( 'before' => '<div class="page-links"><span class="page-links-title">' . __( '身体分割点：', 'twentythirteen' ) . '</span>', 'after' => '</div>', 'link_before' => '<span>', 'link_after' => '</span>' ) ); ?>
		<?php endif; ?>
	</div><!-- .entry-content -->
	<footer class="entry-meta">

		<?php echo getPostLikeLink(get_the_ID()); ?>

		<?php the_tags( '<span class="post-tags">', '', '</span>'); ?>
		
		<span class="post-views"><?php post_views(); ?></span>

		<?php if ( is_single( )) : ?>
			<?php $categories_list = get_the_category_list( __( ', ', 'twentythirteen' ) );
					if ( $categories_list ) {
						echo '<span class="categories-links">' . $categories_list . '</span>';
			}?>
		<?php endif; ?>

		<?php if ( comments_open() ) : ?>
					<span class="leave-reply"><?php comments_popup_link('Leave a reply', '1 Reply ', '% Replies'); ?></span>
		<?php endif; // comments_open() ?>

	</footer><!-- .entry-meta -->
</article><!-- #post -->
		<?php if ( is_single() ) : ?>
				<nav class="nav-single">
					<span class="nav-previous"><?php previous_post_link( '%link', '← %title' ); ?></span>
					<span class="nav-next"><?php next_post_link( '%link', '%title → ' ); ?></span>
					<div class="clearfix"></div>
				</nav><!-- .nav-single -->
		<?php endif; ?>
<hr class="post-eof" />