<?php

function twentythirteen_setup() {

	// Adds RSS feed links to <head> for posts and comments.
	add_theme_support( 'automatic-feed-links' );
	/*
	 * This theme supports all available post formats by default.
	 * See http://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('audio', 'gallery', 'image', 'status') );

	// This theme uses wp_nav_menu() in one location.
	register_nav_menu( 'primary','Top Menu');

	/*
	 * This theme uses a custom image size for featured images, displayed on
	 * "standard" posts and pages.
	 */
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 604, 270, true );

	// This theme uses its own gallery styles.
	add_filter( 'use_default_gallery_style', '__return_false' );
}
add_action( 'after_setup_theme', 'twentythirteen_setup' );


function disable_srcset( $sources ) {
	return false;
}
add_filter( 'wp_calculate_image_srcset', 'disable_srcset' );




$yefengsbg = array('default-color' => 'ffffff','random-default' => false,'flex-height' => false,'flex-width' => false,);
add_theme_support( 'custom-background', $yefengsbg );

  add_image_size('xiangce1', 470, 270); // 别名为 thumb， 尺寸为 150x150 的设定
  add_image_size('xiangce2', 235, 235); // 别名为 recommend， 尺寸为 120x120 的
  add_image_size('xiangce3', 150, 150);


function remove_more_jump_link($link){$offset = strpos($link, '#more-');if ($offset){$end = strpos($link, '"',$offset);}if ($end){ $link = substr_replace($link, '', $offset, $end-$offset);}return $link;}add_filter('the_content_more_link', 'remove_more_jump_link');

function leyaep_custom_login() {echo'<style type="text/css">.login h1 a {margin:0px auto;width: 160px;height: 100px; background-size:160px 100px;}body:after{ content:"Simple-o theme by yefengs";position: absolute;right: 10px;bottom:10px;}</style>';}add_action('login_head', 'leyaep_custom_login');
function leyaep_custom_login_url() {return site_url();}add_filter( 'login_headerurl', 'leyaep_custom_login_url', 10, 4 );


function entry_date( $echo = true ) {
	$format_prefix = '%2$s';
	$date = sprintf( '<time class="date updated" role="update" datetime="%1$s">%2$s</time>',
		esc_attr( get_the_date( 'c' ) ),
		esc_html( sprintf( $format_prefix, get_post_format_string( get_post_format() ), get_the_date() ) )
	);
	if ( $echo )
		echo $date;
	return $date;
}

function post_time_ago( $type = 'post' ) {$d = 'comment' == $type ? 'get_comment_time' : 'get_post_time';echo  human_time_diff($d('U'),current_time('timestamp')),'前';}
function comment_time_ago( $type = 'commennt', $day = 30 ) { $d = $type == 'post' ? 'get_post_time' : 'get_comment_time';    $timediff = time() - $d('U');    if ($timediff <= 60*60*24*$day){ echo  human_time_diff($d('U'), strtotime(current_time('mysql', 0))), '前';    }    if ($timediff > 60*60*24*$day){  echo  date('Y/m/d',get_comment_date('U')), ' ', get_comment_time('H:i');    };  }


function yefengsplayer($atts, $content=null){extract(shortcode_atts(array("auto"=>'0',"loop"=>'0'),$atts));$random = 'm-' . rand(10000,99999);

return '<div class="responsive-wrapper responsive-audio yefengs_player" id="'.$random.'" >
<audio class="progression-single progression-skin progression-minimal-light progression-audio-player" controls="controls" preload="none">
	<source src="'.$content.'" type="audio/mp3"/>
</audio>
</div>';

}
add_shortcode('mp3','yefengsplayer');




function mytheme_get_avatar($avatar) {
$avatar = str_replace(array("www.gravatar.com","0.gravatar.com","1.gravatar.com","2.gravatar.com"),"cn.gravatar.com",$avatar);
$avatar = str_replace("http://","https://",$avatar);
return $avatar;
}
add_filter( 'get_avatar', 'mytheme_get_avatar', 10, 3 );



function infobox($atts, $content=null, $code="") {$return = "<div class='yf_alert yf_alert-info'>";$return .= do_shortcode($content);$return .= "</div>";return $return;}add_shortcode('info' , 'infobox' );
function errorbox($atts, $content=null, $code="") {$return = "<div class='yf_alert yf_alert-error'>";$return .= do_shortcode($content);$return .= "</div>";return $return;}add_shortcode('error' , 'errorbox' );
function downbox($atts, $content=null, $code="") {$return = "<div class='yf_alert yf_alert-success'>";$return .= do_shortcode($content);$return .= "</div>";return $return;}add_shortcode('down' , 'downbox' );
function alertbox($atts, $content=null, $code="") {$return = "<div class='yf_alert'>";$return .= do_shortcode($content);$return .= "</div>";return $return;}add_shortcode('alert' , 'alertbox' );
function whitebox($atts, $content=null, $code="") {$return = "<div class='yf_alert yf_alert-normal'>";$return .= do_shortcode($content);$return .= "</div>";return $return;}add_shortcode('white' , 'whitebox' );
add_action( 'admin_print_footer_scripts', 'shortcode_buttons', 100 );function shortcode_buttons() { ?><script type="text/javascript">QTags.addButton( "music", 'MP3播放器', "[music auto=0]","[/music]");QTags.addButton("alert", "警告", "\n[alert]", "[/alert]\n");QTags.addButton("down", "下载框", "\n[down]", "[/down]\n");QTags.addButton("info", "信息框", "\n[info]", "[/info]\n");QTags.addButton("error", "错误框", "\n[error]", "[/error]\n");QTags.addButton("white", "灰白框", "\n[white]", "[/white]\n");QTags.addButton("nextpage", "分页", "\n<!--nextpage-->\n");QTags.addButton( "loginview", '登录显示', "<!--loginview start-->\n","\n<!--loginview end-->");QTags.addButton( "reply", '回复可见', "[reply]","[/reply]");</script><?php } 



function add_nofollow_to_link($link) {
	return '<div class="more_link">'.$link.'</div>';
}

add_filter('the_content_more_link','add_nofollow_to_link', 0);



add_filter('the_content', 'slimbox', 12);
add_filter('get_comment_text', 'slimbox');
function slimbox ($content) { 
    global $post;
    $pattern = "/<a(.*?)href=('|\")([^>]*).(bmp|gif|jpeg|jpg|png)([^>]*)('|\")(.*?)>(.*?)<\/a>/i";
    $replacement = '<a$1href=$2$3.$4$5$6 id="pirobox_gall_'.$post->ID.'" data-slimbox="slimbox" $7>$8</a>';
    $content = preg_replace($pattern, $replacement, $content);
    return $content;
}

 function par_pagenavi($range = 9){
  global $paged, $wp_query;
  if ( !$max_page ) {$max_page = $wp_query->max_num_pages;}
  if($max_page > 1){if(!$paged){$paged = 1;}
 // if($paged != 1){echo "<a href='" . get_pagenum_link(1) . "' class='extend' title='".'最前一页'."'>".'1'."</a>";}
  previous_posts_link('PREV');
    if($max_page > $range){
    if($paged < $range){for($i = 1; $i <= ($range + 1); $i++){echo "<a href='" . get_pagenum_link($i) ."'";
    if($i==$paged)echo " class='current'";echo ">$i</a>";}}
    elseif($paged >= ($max_page - ceil(($range/2)))){
    for($i = $max_page - $range; $i <= $max_page; $i++){echo "<a href='" . get_pagenum_link($i) ."'";
    if($i==$paged)echo " class='current'";echo ">$i</a>";}}
  elseif($paged >= $range && $paged < ($max_page - ceil(($range/2)))){
    for($i = ($paged - ceil($range/2)); $i <= ($paged + ceil(($range/2))); $i++){echo "<a href='" . get_pagenum_link($i) ."'";if($i==$paged) echo "";echo ">$i</a>";}}}
    else{for($i = 1; $i <= $max_page; $i++){echo "<a href='" . get_pagenum_link($i) ."'";
    if($i==$paged)echo " class='current'";echo ">$i</a>";}}
    if($paged != $max_page){
    echo "<span> ... </span>";   
    echo "<a href='" . get_pagenum_link($max_page) . "' class='extend' title='".'最后一页'."'>".$max_page."</a>";
    }}
    next_posts_link('NEXT');
}

//访问统计
/* 访问计数 */
function record_visitors()
{
	if (is_singular()) 
	{
	  global $post;
	  $post_ID = $post->ID;
	  if($post_ID) 
	  {
		  $post_views = (int)get_post_meta($post_ID, 'views', true);
		  if(!update_post_meta($post_ID, 'views', ($post_views+1))) 
		  {
			add_post_meta($post_ID, 'views', 1, true);
		  }
	  }
	}
}
add_action('wp_head', 'record_visitors');  
 

function get_wp_title_yefengs(){
 if ( is_tag()) { 
 	echo wp_title('Tag:');
 	if($paged > 1) 
 		printf(' - 第%s页',$paged);echo ' | '; bloginfo( 'name' );
 } 
 elseif ( is_archive() ) {
 	echo wp_title('');
 	if($paged > 1) printf(' - 第%s页',$paged);
 	echo ' | ';    bloginfo( 'name' );
 } elseif ( is_search() ) {
 	echo '&quot;'.wp_specialchars($s).'&quot;的搜索结果 | ';
 	 bloginfo( 'name' );
 	} elseif ( is_home() ) {
 		bloginfo( 'name' );
 		$paged = get_query_var('paged'); if($paged > 1) printf(' - 第%s页',$paged);

 	} elseif ( is_404() ) {
 		echo '404错误 页面不存在！ | ';
 		bloginfo( 'name' );
 	} else {
 		echo wp_title( ' | ', false)  ;
 		bloginfo( 'name' );} 

}


function is_ajax_load(){
	return isset( $_GET['ajaxload'] ) && $_GET['ajaxload'] == 'isajax'  && !is_admin();
}
function allajax(){
	remove_action( 'get_footer', '_ajax_wp_die_handler', 1 );
	remove_action( 'get_header', '_ajax_wp_die_handler', 1 );
	record_visitors();
	add_action( 'get_footer', '_ajax_wp_die_handler', 1, 0 );
	echo '<script type="text/javascript"> var title = "';
	echo get_wp_title_yefengs();
	echo '";</script>';
}
if( is_ajax_load())
add_action( 'get_header', 'allajax', 1 );

function example_wp_handle_upload_prefilter($file){
  date_default_timezone_set('PRC');
  $time=date("dHis");
  $time = 'Yefengs'.$time;
  $file['name'] = $time.".".pathinfo($file['name'] , PATHINFO_EXTENSION);
  return $file;
}
add_filter('wp_handle_upload_prefilter', 'example_wp_handle_upload_prefilter');



function yefengs_description() {
    global $s, $post , $wp_query;
    $description = '';
    $blog_name = get_bloginfo('name');
    if ( is_singular() ) {
        $ID = $post->ID;
        $title = $post->post_title;
        $author = $post->post_author;
        $user_info = get_userdata($author);
        $post_author = $user_info->display_name;
        if (!get_post_meta($ID, "meta-description", true)) {$description = $title.' - '.mb_substr(strip_tags($post->post_content),0,210,"utf-8");}
        else {$description = get_post_meta($ID, "meta-description", true);}
    } elseif ( is_home () )    { $description = get_bloginfo( 'description', 'display' );
    } elseif ( is_tag() )      { $description = single_tag_title('', false) . " - ". trim(strip_tags(tag_description()));
    } elseif ( is_category() ) { $description = single_cat_title('', false) . " - ". trim(strip_tags(category_description()));
    } elseif ( is_archive() )  { $description = $blog_name . "'" . trim( wp_title('', false) ) . "'";
    } elseif ( is_search() )   { $description = $blog_name . ": '" . esc_html( $s, 1 ) . "' 的搜索結果";
    }  else { $description = $blog_name . "'" . trim( wp_title('', false) ) . "'";
    }
	$description = str_replace(array("\r\n", "\r", "\n"), "", $description);
    $description = mb_substr( $description, 0, 110, 'utf-8' ).'...';
    echo "<meta name=\"description\" content=\"$description\">\n";
}
add_action('wp_head','yefengs_description',1);




function ludou_comment_add_at( $comment_text, $comment = '') {
  if( $comment->comment_parent > 0) {
    $comment_text = '<span class="at">@'.get_comment_author( $comment->comment_parent ) . '</span>' . $comment_text;
  }

  return $comment_text;
}
add_filter( 'comment_text' , 'ludou_comment_add_at', 20, 2);


/// 函数名称：post_views 
/// 函数作用：取得文章的阅读次数
function post_views($before = '', $after = '℃', $echo = 1)
{
  global $post;
  $post_ID = $post->ID;
  $views = (int)get_post_meta($post_ID, 'views', true);
  if ($echo) echo $before, number_format($views), $after;
  else return $views;
}


function setup_yefengs_like( $post_id ){
    if(!is_numeric($post_id)) return;
    add_post_meta($post_id, 'post_like', '0', true);
}
add_action('publish_post', 'setup_yefengs_like');

add_action('wp_ajax_nopriv_post-like', 'post_like');
add_action('wp_ajax_post-like', 'post_like');

function likescript() {
	//if (!is_admin()) {
	wp_enqueue_script('like_post', "/wp-content/themes/Simple-O/js/js.js?v=20150802",'',false,true);
	wp_localize_script('like_post', 'ajax_var', array(
		'url' => admin_url('admin-ajax.php'),
		'nonce' => wp_create_nonce('ajax-nonce')
	));
}
add_action('wp_enqueue_scripts', 'likescript');
//添加ajax动作

//设定 重复投票延时单位分钟 ，若设为0表示无限制
//$timebeforerevote = 120; // minutes  

function post_like(){
	//  安全性检查
	$nonce = $_POST['nonce'];
	if (! wp_verify_nonce( $nonce, 'ajax-nonce' ))
        die ( '非法请求，我要无情的拒绝!');
	if(isset($_POST['post_like'])){
		$post_id = $_POST['post_id'];
		$meta_count = get_post_meta($post_id, "votes_count", true);
		if(hasAlreadyVoted($post_id)){

		  $votes_count = (int)get_post_meta($post_id, 'votes_count', true);
		  
		  if(!update_post_meta($post_id, 'votes_count', ($votes_count+1))){
			add_post_meta($post_id, 'votes_count', 1, true);
		  }
			$meta_count = get_post_meta($post_id, "votes_count", true);
			setcookie('yefengs_likes_'. $post_id, $post_id,time()+3600*48, '/');
			echo '<span class="likes haslike" title="喜欢过啦~">'.$meta_count.'</span>';
		}
		else
			echo '<span class="likes haslike" title="喜欢过啦~">'.$meta_count.' <b>(～ o ～)~zZ</b></span>';
	}
	exit;
}

function hasAlreadyVoted($post_id){
	$hasvoted = false;
	if( isset($_COOKIE['yefengs_likes_'. $post_id]) ){
		$hasvoted = false;
	}
	else{
		$hasvoted = true;
	}
	return $hasvoted ;
}



function getPostLikeLink($post_id){
	$vote_count = get_post_meta($post_id, "votes_count", true);
	$yefengs_like_class="";
	if(($vote_count=="")) $vote_count = 0;
 	if (isset($_COOKIE['yefengs_likes_'. $post_id]))
 		$yefengs_like_class="haslike";
	$output = '<span class="post-likes"><span title="喜欢~" class="likes '.$yefengs_like_class.'" data-post_id="'.$post_id.'">'.$vote_count.'</span></span>';
	return $output;
}

function scp_comment_post( $incoming_comment ) {
    $pattern = '/[一-龥]/u'; 
    // 禁止全英文评论
    if(!preg_match($pattern, $incoming_comment['comment_content'])) {
	ajax_comment_err('You should type some Chinese word (like \"你好\") in your comment to pass the spam-check, thanks for your patience! 您的评论中必须包含汉字!');
    }
    return( $incoming_comment );
}
add_filter('preprocess_comment', 'scp_comment_post');



function wp_get_user_id(){
    global $userdata;
    get_currentuserinfo();
    return $userdata->ID;
}
function Check_the_number_of_users_published_today( $incoming_comment ){
	$user_ID_D = (int)wp_get_user_id();//获取当前登录用户ID
	$weekdayis = date("w",time() + 8*60*60);//获取今天是星期几
	if( $weekdayis== 0 || $weekdayis == 8 ) { //若是星期六或天，则限制数为10
		$limit = 1;
	}else{
		$limit = 1;//否则为10条
	}
	global $wpdb;
	echo "string!!!!!";
	$sqlstyle ="select count(*) from wp_comments where user_id='".$user_ID_D."' and DATE_FORMAT( comment_date ,'%Y-%m-%d') = DATE_FORMAT( DATE_ADD( NOW(), Interval 8 HOUR) ,'%Y-%m-%d')";
	$comment_count = $wpdb->get_var($sqlstyle);
	if ($comment_count >= $limit) {
		 ajax_comment_err('哈哈哈~评论数量达到上限啦~');
		//echo "test check";
	}
	return( $incoming_comment );
}
//add_filter( 'preprocess_comment', 'Check_the_number_of_users_published_today' );



function WelcomeCommentAuthorBack($email = ''){
      if(empty($email)){
        return;
      }
      global $wpdb;
      $past_30days = gmdate('Y-m-d H:i:s',((time()-(24*60*60*30))+(get_option('gmt_offset')*3600)));
      $sql = "SELECT count(comment_author_email) AS times FROM $wpdb->comments
              WHERE comment_approved = '1'
              AND comment_author_email = '$email'
              AND comment_date >= '$past_30days'";
      $times = $wpdb->get_results($sql);
      $times = ($times[0]->times) ? $times[0]->times : 0;
      $message = $times ? sprintf(__('在过去的一个多月里你居然有<strong>%1$s</strong>次留言，你太给力了！' ), $times) : '我猜你肯定很久没来看我了，肯定想我了，你想说些什么秘密呢？';
      return $message;
}

function checkadmin(){
    $adminEmail = get_option('admin_email');
    if(get_comment_author_email() ==$adminEmail){
    	return true;
    }else{
    	return false;
   }
}

function yefengs_comment_text( $comment_text ) {
    $comment = get_comment( $comment_ID );
    echo apply_filters( 'comment_text', $comment_text, $comment );
}

function yefengs_theme_comment($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment; 
	?>
 <li <?php comment_class(); ?> >
    <div class="comment-lists<?php if ($comment->comment_parent > 0) { echo ' leftgo';} ?>" id="comment-<?php comment_ID() ?>">
		<section  class="y_avatar">
			<?php echo get_avatar( get_comment_author_email(), '40'); ?>
			<span><?php comment_reply_link( array_merge( $args, array( 'reply_text' => '回复','login_text' =>'回复', 'after' => '', 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?></span>
		</section>
	    <section class="comment_con <?php if (checkadmin()) { echo "admin"; } ?>">
            <div class="comment_info">  
	    		<cite class="vcard"><a class="linkforavater <?php if(checkadmin()) {echo "admin"; }?>" href="<?php  if (get_comment_author_url()) 
	        echo esc_url( home_url( '/' ) ).'?home='. base64_encode(get_comment_author_url()); 
	        else  echo "javascript:;"; ?>" title=" <?php echo get_comment_author(); ?> " target="_blank" rel="external nofollow" ><?php echo get_comment_author(); ?></a></cite>
	            <span class="commentinfo"><?php comment_time_ago();?>&nbsp;</span>
	        </div>
		<div class="c-say">
			<?php 
				comment_text();
			?>
		</div>
        </section>
	    <div class="clearfix"></div>
	</div>
<?php 
	}//end comments big


/* Ajax无限评论翻页 by winy */
function AjaxCommentsPage() {
  if ( isset($_GET["yefengs"]) && $_GET["yefengs"] == "GetComments" ) {
    global $post,$wp_query, $wp_rewrite;
    $postid = isset($_GET["post"]) ? $_GET["post"] : null;
    $pageid = isset($_GET["page"]) ? $_GET["page"] : null;
    if ( !$postid || !$pageid ) {
      fail(__("Error post id or comment page id."));
    }
    // get comments
    $comments = get_comments("post_id=" . $postid);
    $post = get_post($postid);
    if ( !$comments ) {
      fail(__("啊哈~居然没有评论"));
    }
    if( "desc" != get_option("comment_order") ){
      $comments = array_reverse($comments);
    }
    // set as singular (is_single || is_page || is_attachment)
    $wp_query->is_singular = true;
    // base url of page links
    $baseLink = "";
    if ( $wp_rewrite->using_permalinks() ) {
      $baseLink = user_trailingslashit(get_permalink($postid) . "/comment-page-%#%", "commentpaged");
    }
    // response 下一行WinyskyComments注意修改callback为你自己的回调函数 
    echo '<ol class="comment-list">';
    if ("desc" == get_option("comment_order"))echo '<div id="desc"></div>';
	$totalPage = '&total='.get_comment_pages_count($comments);
	wp_list_comments("type=comment&callback=yefengs_theme_comment&page=" . $pageid . "&per_page=" . get_option("comments_per_page"), $comments);
    if ("desc" != get_option("comment_order"))echo '<div id="desc"></div>';
    echo '</ol>';
    echo '<nav id="commentnav" role="navigation">';
    paginate_comments_links('current=' . $pageid . $totalPage . $baseLink . '&prev_text=上页&next_text=下页&current=' . $pageid . $baseLink);
    echo "</nav>";
    die;
  } else {
    return;
  }
}
add_action('init', 'AjaxCommentsPage');


// comment_mail_notify v1.0 by willin kan. (所有回覆都發郵件)
function comment_mail_notify($comment_id) {
        $comment = get_comment($comment_id);
        $parent_id = $comment->comment_parent ? $comment->comment_parent : '';
        $spam_confirmed = $comment->comment_approved;
        if (($parent_id != '') && ($spam_confirmed != 'spam')) {
        $wp_email = 'no-reply@' . preg_replace('#^www\.#', '', strtolower($_SERVER['SERVER_NAME'])); //e-mail 發出點, no-reply 可改為可用的 e-mail.
        $to = trim(get_comment($parent_id)->comment_author_email);
      $subject = ' [' . get_option("blogname") . '] 的信使';
        $message = '<div style="background-color:#fff; border:1px solid #666666; color:#111;border-radius:8px; font-size:13px; width:702px; margin:0 auto; margin-top:10px; font-family:微软雅黑, Arial;">
         <div style="background:#666666; width:100%; height:60px; color:white; border-radius:6px 6px 0 0; "><span style="height:60px; line-height:60px; margin-left:30px; font-size:20px;">您在<a style="text-decoration:none; color:#00bbff;font-weight:600;" href="' . get_option('home') . '" target="_blank">' . get_option('blogname') . '</a>博客上的留言有回复啦！</span></div>
         <div style="width:90%; margin:0 auto">
         <p>' . trim(get_comment($parent_id)->comment_author) . ', 您好!</p>
         <p>您曾在《' . get_the_title($comment->comment_post_ID) . '》的留言:</p>
         <p style="background-color: #EEE;border: 1px solid #DDD;padding: 10px 5px;margin: 15px 0;">'
         . trim(get_comment($parent_id)->comment_content) . '</p>
         <p>' . trim($comment->comment_author) . ' 给您的回复:</p>
         <p style="background-color: #EEE;border: 1px solid #DDD;padding:10px 5px;margin: 15px 0;">
          '. trim($comment->comment_content) . '</p>
         <p>您可以点击 <a style="text-decoration:none; color:#00bbff" href="' . htmlspecialchars(get_comment_link($parent_id)) . '">查看回复的完整內容</a></p>
          <p>欢迎再次光临 <a style="text-decoration:none; color:#00bbff" href="' . get_option('home') . '">' . get_option('blogname') . '</a></p>
         <p style="color:red;">(温馨提示：本邮件由系统自动发出，切勿回复)</p>
          </div>
         </div>';
        $from = "From: \"" . get_option('blogname') . "\" <$wp_email>";
        $headers = "$from\nContent-Type: text/html; charset=" . get_option('blog_charset') . "\n";
        wp_mail( $to, $subject, $message, $headers );
            }
      } add_action('comment_post', 'comment_mail_notify');

/* -----------------------------------------------
<<小牆>> Anti-Spam v1.9 by Willin Kan.
*/
//建立
class anti_spam {
  function anti_spam() {
    if ( !is_user_logged_in() ) {
      add_action('template_redirect', array($this, 'w_tb'), 1);
      add_action('pre_comment_on_post', array($this, 'gate'), 1);
      add_action('preprocess_comment', array($this, 'sink'), 1);
    }
  }
  //設欄位
  function w_tb() {
    if ( is_singular() ) {
      ob_start(create_function('$input', 'return preg_replace("#textarea(.*?)name=([\"\'])comment([\"\'])(.+)/textarea>#",
      "textarea$1name=$2w$3$4/textarea><textarea name=\"comment\" cols=\"60\" rows=\"4\" style=\"display:none\"></textarea>", $input);') );
    }
  }
  //檢查
  function gate() {
    ( !empty($_POST['w']) && empty($_POST['comment']) ) ? $_POST['comment'] = $_POST['w'] : $_POST['spam_confirmed'] = 1;
  }
  //處理
  function sink( $comment ) {
    if ( !empty($_POST['spam_confirmed']) ) {
      //方法一:直接擋掉, 將 die(); 前面兩斜線刪除即可.
      //die();
      //方法二:標記為spam, 留在資料庫檢查是否誤判.
      add_filter('pre_comment_approved', create_function('', 'return "spam";'));
      $comment['comment_content'] = "[ 可能是垃圾评论! ]\n " . $comment['comment_content'];
    }
    return $comment;
  } 
}
$anti_spam = new anti_spam();
// -- END ----------------------------------------

function yefengs_the_content_nofollow($content) {
    preg_match_all('/href="(.*?)"/', $content, $matches);
    if ($matches) {
        foreach ($matches[1] as $val) {
            if (strpos($val, home_url()) === false) {
              $val= esc_url( home_url( '/' ) ).'?home='. base64_encode($val);
                $content = str_replace("href=\"{$val}\"", "href=\"{$val}\" rel=\"external nofollow\" class=\"externall\"", $content);
            }
        }
    }
    return $content;
}
add_filter('the_content', 'yefengs_the_content_nofollow', 999);
add_filter('get_comment_text', 'slimbox');
/**
* @author yefengs
* @version 1.1
*  
*
*/
function gohome() {
	if ( isset($_GET['home'])) {
		$str = $_GET["home"];
			if ($str == base64_encode(base64_decode($str)) && !empty($str)) {
			header('location:'.base64_decode($str));
		}else{
			$str=$_SERVER["HTTP_REFERER"];
			header('location:'.$str);
		}
	}
}
add_action('init', 'gohome');


add_action('wp_ajax_nopriv_ajax_comment', 'ajax_comment');
add_action('wp_ajax_ajax_comment', 'ajax_comment');
function ajax_comment(){
    global $wpdb;
    //nocache_headers();
    $comment_post_ID = isset($_POST['comment_post_ID']) ? (int) $_POST['comment_post_ID'] : 0;
    $post = get_post($comment_post_ID);
    $post_author = $post->post_author;
   if ( empty($post->comment_status) ) {
        do_action('comment_id_not_found', $comment_post_ID);
        ajax_comment_err('Invalid comment status.');
    }
    $status = get_post_status($post);
    $status_obj = get_post_status_object($status);
    if ( !comments_open($comment_post_ID) ) {
        do_action('comment_closed', $comment_post_ID);
        ajax_comment_err('Sorry, comments are closed for this item.');
    } elseif ( 'trash' == $status ) {
        do_action('comment_on_trash', $comment_post_ID);
        ajax_comment_err('Invalid comment status.');
    } elseif ( !$status_obj->public && !$status_obj->private ) {
        do_action('comment_on_draft', $comment_post_ID);
        ajax_comment_err('Invalid comment status.');
    } elseif ( post_password_required($comment_post_ID) ) {
        do_action('comment_on_password_protected', $comment_post_ID);
        ajax_comment_err('Password Protected');
    } else {
        do_action('pre_comment_on_post', $comment_post_ID);
    }
    $comment_author       = ( isset($_POST['author']) )  ? trim(strip_tags($_POST['author'])) : null;
    $comment_author_email = ( isset($_POST['email']) )   ? trim($_POST['email']) : null;
    $comment_author_url   = ( isset($_POST['url']) )     ? trim($_POST['url']) : null;
    $comment_content      = ( isset($_POST['comment']) ) ? trim($_POST['comment']) : null;
	$edit_id              = ( isset($_POST['edit_id']) ) ? $_POST['edit_id'] : null; // 提取 edit_id
    $user = wp_get_current_user();
    if ( $user->exists() ) {
        if ( empty( $user->display_name ) )
            $user->display_name=$user->user_login;
        $comment_author       = $wpdb->escape($user->display_name);
        $comment_author_email = $wpdb->escape($user->user_email);
        $comment_author_url   = $wpdb->escape($user->user_url);
        $user_ID			  = $wpdb->escape($user->ID);
        if ( current_user_can('unfiltered_html') ) {
            if ( wp_create_nonce('unfiltered-html-comment_' . $comment_post_ID) != $_POST['_wp_unfiltered_html_comment'] ) {
                kses_remove_filters();
                kses_init_filters();
            }
        }
    } else {
        if ( get_option('comment_registration') || 'private' == $status )
            ajax_comment_err('哈哈哈~你必须登陆后才可以留言的说.');
    }
    $comment_type = '';
    if ( get_option('require_name_email') && !$user->exists() ) {
        if ( 6 > strlen($comment_author_email) || '' == $comment_author )
            ajax_comment_err( '哈哈~~你必须输入昵称和邮箱才可以留言' );
        elseif ( !is_email($comment_author_email))
            ajax_comment_err( '鄙视你！你居然连邮箱地址都输不正确~' );
    }
    if ( '' == $comment_content )
        ajax_comment_err( '出错啦~~难道你就没有话想说嘛~' );
    $dupe = "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = '$comment_post_ID' AND ( comment_author = '$comment_author' ";
    if ( $comment_author_email ) $dupe .= "OR comment_author_email = '$comment_author_email' ";
    $dupe .= ") AND comment_content = '$comment_content' LIMIT 1";
    if ( $wpdb->get_var($dupe) ) {
        ajax_comment_err('貌似，大概，好像你说过这句话了~');
    }
    if ( $lasttime = $wpdb->get_var( $wpdb->prepare("SELECT comment_date_gmt FROM $wpdb->comments WHERE comment_author = %s ORDER BY comment_date DESC LIMIT 1", $comment_author) ) ) {
        $time_lastcomment = mysql2date('U', $lasttime, false);
        $time_newcomment  = mysql2date('U', current_time('mysql', 1), false);
        $flood_die = apply_filters('comment_flood_filter', false, $time_lastcomment, $time_newcomment);
        if ( $flood_die ) {
            ajax_comment_err('你说的太快了，不着急，慢慢说~');
        }
    }
    $comment_parent = isset($_POST['comment_parent']) ? absint($_POST['comment_parent']) : 0;
    $commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'comment_parent', 'user_ID');

    if ( $edit_id )
{
    $comment_id = $commentdata['comment_ID'] = $edit_id;
    if( ihacklog_user_can_edit_comment($commentdata,$comment_id) )
    {  
        wp_update_comment( $commentdata );
    }
    else
    {
        ajax_comment_err( 'Cheatin&#8217; uh? ' );
    }

}
else
{
$comment_id = wp_new_comment( $commentdata );
}

    $comment = get_comment($comment_id);
    do_action('set_comment_cookies', $comment, $user);
    $comment_depth = 1;
    $tmp_c = $comment;
    while($tmp_c->comment_parent != 0){
        $comment_depth++;
        $tmp_c = get_comment($tmp_c->comment_parent);
    }
    $GLOBALS['comment'] = $comment;
    ?>
<li <?php comment_class(); ?> >
    <div class="comment-lists<?php if ($comment->comment_parent > 0) { echo ' leftgo';} ?>" id="comment-<?php comment_ID() ?>">
		<section  class="y_avatar">
			<?php echo get_avatar( get_comment_author_email(), '40'); ?>
		</section>
	    <section class="comment_con <?php if (checkadmin()) { echo "admin"; } ?>">
            <div class="comment_info">  
	    		<cite class="vcard"><a class="linkforavater <?php if(checkadmin()) {echo "admin"; }?>" href="<?php  if (get_comment_author_url()) 
	        echo esc_url( home_url( '/' ) ).'?home='. base64_encode(get_comment_author_url()); 
	        else  echo "javascript:;"; ?>" title=" <?php echo get_comment_author(); ?> " target="_blank" rel="external nofollow" ><?php echo get_comment_author(); ?></a></cite>
	            <span class="commentinfo">刚刚&nbsp;</span>
	        </div>
		<div class="c-say">
			<?php 
				comment_text();
			?>
		</div>
        </section>
	    <div class="clearfix"></div>
	</div>

    <?php die();

}
function ajax_comment_err($a) {
    header('HTTP/1.0 500 Internal Server Error');
    header('Content-Type: text/plain;charset=UTF-8');
    echo $a;
    exit;
}

function ihacklog_user_can_edit_comment($new_cmt_data,$comment_ID = 0) {
    if(current_user_can('edit_comment', $comment_ID)) {
        return true;
    }
    $comment = get_comment( $comment_ID );
    $old_timestamp = strtotime( $comment->comment_date);
    $new_timestamp = current_time('timestamp');
    // 不用get_comment_author_email($comment_ID) , get_comment_author_IP($comment_ID)
    $rs = $comment->comment_author_email === $new_cmt_data['comment_author_email']
            && $comment->comment_author_IP === $_SERVER['REMOTE_ADDR']
                && $new_timestamp - $old_timestamp < 3600;
    return $rs;
}